"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.unstable_shouldOnCreateNode = unstable_shouldOnCreateNode;
exports.onCreateNode = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _crypto = _interopRequireDefault(require("crypto"));

function unstable_shouldOnCreateNode(_ref) {
  var node = _ref.node;
  // We only care about JSON content.
  return node.internal.mediaType === "application/json";
}

var onCreateNode = /*#__PURE__*/function () {
  var _ref3 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(_ref2, pluginOptions) {
    var node, actions, loadNodeContent, reporter, absolutePath, _node$internal, mediaType, type, sourceInstanceName, relativeDirectory, name, id, createNode, createParentChildLink, targetSourceInstanceName, activity, content, data, hint, contentDigest, localeNode;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            node = _ref2.node, actions = _ref2.actions, loadNodeContent = _ref2.loadNodeContent, reporter = _ref2.reporter;

            if (unstable_shouldOnCreateNode({
              node: node
            })) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return");

          case 3:
            absolutePath = node.absolutePath, _node$internal = node.internal, mediaType = _node$internal.mediaType, type = _node$internal.type, sourceInstanceName = node.sourceInstanceName, relativeDirectory = node.relativeDirectory, name = node.name, id = node.id;

            if (!(pluginOptions.sourceInstanceName == null)) {
              _context.next = 6;
              break;
            }

            return _context.abrupt("return");

          case 6:
            createNode = actions.createNode, createParentChildLink = actions.createParentChildLink;
            targetSourceInstanceName = pluginOptions.sourceInstanceName;

            if (!(type !== 'File' || sourceInstanceName !== targetSourceInstanceName)) {
              _context.next = 10;
              break;
            }

            return _context.abrupt("return");

          case 10:
            activity = reporter.activityTimer("gatsby-plugin-react-i18next: create node: " + relativeDirectory + "/" + name);
            activity.start();
            _context.next = 14;
            return loadNodeContent(node);

          case 14:
            content = _context.sent;
            _context.prev = 15;
            data = JSON.stringify(JSON.parse(content), undefined, '');
            _context.next = 23;
            break;

          case 19:
            _context.prev = 19;
            _context.t0 = _context["catch"](15);
            hint = node.absolutePath ? "file " + node.absolutePath : "in node " + node.id;
            throw new Error("Unable to parse JSON: " + hint);

          case 23:
            contentDigest = _crypto.default.createHash("md5").update(content).digest("hex");
            localeNode = {
              id: id + " >>> Locale",
              children: [],
              parent: id,
              internal: {
                content: content,
                contentDigest: contentDigest,
                type: "Locale"
              },
              lng: relativeDirectory,
              ns: name,
              data: data,
              fileAbsolutePath: absolutePath
            };
            createNode(localeNode); // @ts-ignore
            // staled issue: https://github.com/gatsbyjs/gatsby/issues/19993

            createParentChildLink({
              parent: node,
              child: localeNode
            });
            activity.end();

          case 28:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[15, 19]]);
  }));

  return function onCreateNode(_x, _x2) {
    return _ref3.apply(this, arguments);
  };
}();

exports.onCreateNode = onCreateNode;